<template>
    <div>
      <div class="gva-search-box">
        <el-form ref="searchForm" :inline="true" :model="searchInfo">
          <el-form-item label="电脑编号">
            <el-input v-model="searchInfo.pc_code" placeholder="电脑编号" />
          </el-form-item>
          <el-form-item label="使用者">
            <el-input v-model="searchInfo.operator" placeholder="使用者" />
          </el-form-item>
          <el-form-item label="状态">
          <el-select v-model="searchInfo.status" placeholder="日志状态" >
              <el-option
                v-for="item in searchStatusOptions"
                :key="item.value"
                :label="item.label"
                :value="item.value"
                :disabled="item.disabled"
              />
            </el-select>
        </el-form-item>
          <el-form-item label="日期" prop="create_date">
           <el-date-picker
            v-model="searchInfo.create_date"
            popper-class="picker-popovers"
            class="timefilter"
            type="datetime"
            placeholder="选择日期时间"
            value-format="YYYY-MM-DD"
          >
          </el-date-picker>
          </el-form-item>
          <el-form-item>
            <el-button size="small" type="primary" icon="search" @click="onSubmit">查询</el-button>
            <el-button size="small" icon="refresh" @click="onReset">重置</el-button>
          </el-form-item>
        </el-form>
      </div>
      <div class="gva-table-box">
        <div class="gva-btn-list">
        <el-button class="excel-btn" size="small" type="primary" icon="download" @click="handleExcelExport">导出</el-button>
      </div>
        <el-table :data="tableData"  @sort-change="sortChange" @selection-change="handleSelectionChange"
        border
        >
          
          <el-table-column align="left" label="电脑编号" min-width="100" prop="pc_code" sortable="custom"/>
          <el-table-column align="left" label="使用者" min-width="150" prop="operator" sortable="custom"/>
          <el-table-column align="left" label="日期" min-width="150" prop="create_date" />
          <el-table-column align="left" label="拉取账号" min-width="150" prop="pull_account_total" />
          <el-table-column align="left" label="进入主线" min-width="150" prop="enter_main_total" />
          <el-table-column label="主线成功率" align="center"  min-width="100">
            <template #default="scope">
							{{ scope.row.enter_main_total == 0 || scope.row.pull_account_total == 0 ? 0 + '%' : Math.round(scope.row.enter_main_total/scope.row.pull_account_total * 10000) / 100 + '%'}}
						</template>
          </el-table-column>
          <el-table-column align="left" label="状态" min-width="150" prop="status" >
          <template #default="scope">
            <div>
              <el-tag :type="scope.row.status === -1 ? 'warning' : 'success'">{{ statusFiletr(scope.row.status) }}</el-tag>
            </div>
          </template>
        </el-table-column>
        <el-table-column align="left" label="备注" min-width="150" prop="remarks" />
        <el-table-column align="left" fixed="right" label="操作" width="200">
          <template #default="scope">
            <el-button
              icon="edit"
              size="small"
              type="primary"
              link
              @click="editCardFunc(scope.row)"
            >添加备注</el-button>
          </template>
        </el-table-column>
        
        </el-table>
        <div class="gva-pagination">
          <el-pagination
            :current-page="page"
            :page-size="pageSize"
            :page-sizes="[10, 30, 50, 100]"
            :total="total"
            layout="total, sizes, prev, pager, next, jumper"
            @current-change="handleCurrentChange"
            @size-change="handleSizeChange"
          />
        </div>
  
      </div>
  
      <el-dialog v-model="dialogFormVisible" :before-close="closeDialog" :title="dialogTitle">
        <el-form ref="apiForm" :model="form" :rules="rules" label-width="80px">
          <el-form-item label="备注" prop="remarks">
            <el-input v-model="form.remarks" autocomplete="off" />
          </el-form-item>
        </el-form>
        <template #footer>
          <div class="dialog-footer">
            <el-button size="small" @click="closeDialog">取 消</el-button>
            <el-button size="small" type="primary" @click="enterDialog">确 定</el-button>
          </div>
        </template>
      </el-dialog>
    </div>
  </template>
  
  <script>
  export default {
    name: 'ComputerUseLog',
  }
  </script>
  
  <script setup>
  import {
    computerUseLog,
    exportExcel,
    updateComputerUseRemarks,
  } from '@/api/log'
  import { toSQLLine } from '@/utils/stringFun'
  import { ref } from 'vue'
  import { ElMessage, ElMessageBox } from 'element-plus'
  import warningBar from '@/components/warningBar/warningBar.vue'
  
  const apis = ref([])
  const form = ref({
      game_name: '',
      game_package_name: ''
  })

  const statusOptions = ref([
  {
    value: -1,
    label: '没有上报',
    type: 'wain'
  },
  {
    value: 1,
    label: '中控上报',
    type: 'success'
  },
  {
    value: 2,
    label: '任务上报',
    type: 'success'
  }
])
  
  const statusFiletr = (value) => {
  const target = statusOptions.value.filter(item => item.value === value)[0]
  return target && `${target.label}`
}


const searchStatusOptions = ref([
 {
    value: -1,
    label: '没有上报',
    type: 'wain'
  },
  {
    value: 1,
    label: '中控上报',
    type: 'success'
  },
  {
    value: 2,
    label: '任务上报',
    type: 'success'
  }
])
  
  const type = ref('')
  const rules = ref({
    remarks: [{ required: true, message: '请添加备注', trigger: 'blur' }],
    game_package_name: [
      { required: true, message: '请输入游戏包名', trigger: 'blur' }
    ]
  })
  
  const typeFiletr = (value) => {
    const target = typeOptions.value.filter(item => item.value === value)[0]
    return target && `${target.label}`
  }
    
    const typeOptions = ref([
    {
      value: 0,
      label: '脚本',
      type: ''
    },
    {
      value: 1,
      label: '中控',
      type: ''
    }
  ])
  
  const page = ref(1)
  const total = ref(0)
  const pageSize = ref(10)
  const tableData = ref([])
  let spanArr = []
  const searchInfo = ref({})
  
  const onReset = () => {
    searchInfo.value = {}
  }
  
  // 搜索
  
  const onSubmit = () => {
    page.value = 1
    pageSize.value = 10
    searchInfo.value.game_id = Number(searchInfo.value.game_id)
    searchInfo.value.coding = Number(searchInfo.value.coding)
    getTableData()
  }

  const getSpanArr = (data) => {
    spanArr = []
    var pos = 0
    for (var i = 0; i < data.length; i++) {
          if (i === 0) {
            spanArr.push(1);
            pos = 0
          } else {
            if (data[i].pc_code === data[i - 1].pc_code) {
              spanArr[pos] += 1;
              spanArr.push(0);
            } else {
              spanArr.push(1);
              pos = i;
            }
          }
        }
        console.log(spanArr)  
  }

  const objectSpanMethod = (row) => {
    if (row.columnIndex === 1 || row.columnIndex === 2 || row.columnIndex === 3 || row.columnIndex === 0) {
          const rowspan = spanArr[row.rowIndex];
          const colspan = rowspan > 0 ? 1 : 0;
          return {
            rowspan: rowspan,
            colspan: colspan
          }
        }
  }
 

  
  // 分页
  const handleSizeChange = (val) => {
    pageSize.value = val
    getTableData()
  }
  
  const handleCurrentChange = (val) => {
    page.value = val
    getTableData()
  }
  
  // 排序
  const sortChange = ({ prop, order }) => {
    if (prop) {
      if (prop === 'id') {
        prop = 'id'
      }
      searchInfo.value.orderKey = toSQLLine(prop)
      searchInfo.value.desc = order === 'descending'
    }
    console.log(searchInfo.value.create_date)
    
    getTableData()
  }

  const handleExcelExport = async() => {
    var fileName = Date.parse(new Date()) + "-pc.xlsx"
    if(searchInfo.value.create_date == null){
      let dt = new Date()
            var y = dt.getFullYear()
            var mt = (dt.getMonth() + 1).toString().padStart(2,'0')
            var day = dt.getDate().toString().padStart(2,'0')
            var timeStr = y + "-" + mt + "-" + day
      fileName = timeStr + "-pc.xlsx"
    }else{
      fileName = searchInfo.value.create_date + "-pc.xlsx"
    }
  exportExcel({ page: page.value, pageSize: pageSize.value, ...searchInfo.value },fileName)
}
  
  // 查询
  const getTableData = async() => {
    const table = await computerUseLog({ page: page.value, pageSize: pageSize.value, ...searchInfo.value })
    if (table.code === 0) {
      tableData.value = table.data.list
      total.value = table.data.total
      page.value = table.data.page
      pageSize.value = table.data.pageSize
     
    }
  }

  getTableData()
  
  // 批量操作
  const handleSelectionChange = (val) => {
    apis.value = val
  }
  
  
  // 弹窗相关
  const apiForm = ref(null)
  const initForm = () => {
    apiForm.value.resetFields()
    form.value = {
      remarks: '',
    }
  }
  
  const dialogTitle = ref('新增game')
  const dialogFormVisible = ref(false)
  const openDialog = (key) => {
    switch (key) {
      case 'addGame':
        dialogTitle.value = '新增game'
        break
      case 'edit':
        dialogTitle.value = '修改备注'
        break
      default:
        break
    }
    type.value = key
    dialogFormVisible.value = true
  }
  const closeDialog = () => {
    initForm()
    dialogFormVisible.value = false
  }
  
  const editCardFunc = async(row) => {
    form.value = row
    openDialog('edit')
  }
  
  const enterDialog = async() => {
    apiForm.value.validate(async valid => {
      if (valid) {
        switch (type.value) {
          case 'addGame':
            {
              const res = await cuGame(form.value)
              if (res.code === 0) {
                ElMessage({
                  type: 'success',
                  message: '添加成功',
                  showClose: true
                })
              }
              getTableData()
              closeDialog()
            }
  
            break
          case 'edit':
            {
              const res = await updateComputerUseRemarks(form.value)
              if (res.code === 0) {
                ElMessage({
                  type: 'success',
                  message: '编辑成功',
                  showClose: true
                })
              }
              getTableData()
              closeDialog()
            }
            break
          default:
            // eslint-disable-next-line no-lone-blocks
            {
              ElMessage({
                type: 'error',
                message: '未知操作',
                showClose: true
              })
            }
            break
        }
      }
    })
  }
  
  
  </script>
  
  <style scoped lang="scss">
  .button-box {
    padding: 10px 20px;
    .el-button {
      float: right;
    }
  }
  .warning {
    color: #dc143c;
  }
  </style>
  